// Elektronicka hazeci kostka na UNO / ATTINY85

//defines for UNO      
//#define  led_1  4         //stredova led pro cisla 1, 3, 5 
//#define  led_2  5         //dvojice led pro cisla 2, 3, 4, 5, 6 
//#define  led_4  6         //dvojice led pro cisla 4, 5, 6 
//#define  led_6  7         //dvojice led pro cislo 6
//#define  tlacitko  A0     //tlacitko kostky 
//#define  pruchod 100      // pocet pruchodu debouncingem


//defines for ATTINY85
        
#define  led_1  0         //stredova led pro cisla 1, 3, 5 
#define  led_2  1         //dvojice led pro cisla 2, 3, 4, 5, 6 
#define  led_4  3         //dvojice led pro cisla 4, 5, 6 
#define  led_6  4         //dvojice led pro cislo 6
#define  tlacitko  2      //tlacitko kostky 
#define  pruchod 70      // pocet pruchodu debouncingem


byte kostka;              //hozene cislo
byte pkostka1, pkostka2;  //pomocna hodnota kostky pri dotaceni
byte keycnt;              //pocitadlo pruchodu debouncingem
byte dotoc;               //počet dotočení kostky (x100 ms)
word citac;               //citac pro blikani LED
long rseed;               //random seed
word pdel;

void setup() {      
 pinMode(led_1, OUTPUT);     
 pinMode(led_2, OUTPUT);     
 pinMode(led_4, OUTPUT);     
 pinMode(led_6, OUTPUT);     
 zhasni_kostku(); 
  
 pinMode(tlacitko, INPUT_PULLUP);      
 
 randomSeed(123123);        //pocatecni random seed
  
 //Serial.begin(19200); // setup serial
 //Serial.println("KOSTKA"); 
 //Serial.println(" "); // empty line
 
 citac = 11998;             //pocatecni hodnota citace - blikame hned
}


void loop() {
  
  kostka = random(1,7);
  
  //Serial.println("Cekame na uvolneni tlacitka..."); 
  tlac_uvol();
  
  //Serial.println("Cekame na stisk tlacitka..."); 
  keycnt = pruchod;
  do {
  if (digitalRead(tlacitko)==LOW) {keycnt--;} else {keycnt = pruchod;}  
  inc_kostka();
  citac++;
  if (citac == 12000) {zhasni_kostku(); digitalWrite (led_1, LOW);}
  if (citac == 12450) {digitalWrite (led_1, HIGH);}
  if (citac == 12900) {citac = 11998;}
  delayMicroseconds (400);
  } while (keycnt > 0);
  
  zhasni_kostku();
  citac = 0;
  
  //Serial.println("Cekame na opetovne uvolneni tlacitka..."); 
  tlac_uvol();
  
  //Serial.println("Cekame na dotoceni kostky..."); 
  dotoc = random(20, 27);
  pdel = 80;
  
  pkostka1 = 0;                 //schvalne mimo povoleny rozsah, aby se hned napoprve zobrazovalo.
  for (int i=0; i<dotoc; i++){
    do {
    pkostka2 = random(1,7);
    } while (pkostka2 == pkostka1);
    pkostka1 = pkostka2;
    ukaz_kostku(pkostka1);
    //Serial.println(pkostka1);
    delay(pdel);
    pdel = pdel + 6; 
    inc_kostka();
   }
  
  //Serial.print("Padlo cislo: "); // debug value Center
  //Serial.println(kostka); // debug value Center
  //Serial.println(" "); // empty line
  
  if (kostka>6) {kostka=6;}        //jen pro sichr
  if (kostka<1) {kostka=1;}        //jen pro sichr
   
  ukaz_kostku(kostka);             //zobrazi stav kostky
  
  rseed = kostka * dotoc;
  randomSeed(rseed);              //novy random seed
  
}

//************************* uzivatelske funkce ************************************

void tlac_uvol()
{
keycnt = pruchod;
  do {
  if (digitalRead(tlacitko)==HIGH) {keycnt--;} else {keycnt = pruchod;}  
  inc_kostka();
  } while (keycnt > 0);
return;
}


void inc_kostka()
{
kostka++;
if (kostka>6) {kostka=1;}
return;
}


void zhasni_kostku()
{
  digitalWrite (led_1, HIGH); 
  digitalWrite (led_2, HIGH); 
  digitalWrite (led_4, HIGH); 
  digitalWrite (led_6, HIGH); 
  return;
}

void ukaz_kostku(byte ukaz)
{
zhasni_kostku(); 
  
  switch (ukaz) {    
    case 1: { 
            digitalWrite (led_1, LOW); 
    }                   
                   break;
                                   
    case 2: { 
            digitalWrite (led_2, LOW); 
    }                   
                   break;      
          
    case 3: { 
            digitalWrite (led_1, LOW);
            digitalWrite (led_2, LOW);
    }                   
                   break;                   
                       
    case 4: { 
            digitalWrite (led_2, LOW);
            digitalWrite (led_4, LOW);
    }                   
                   break;                                  
                   
    case 5: { 
            digitalWrite (led_1, LOW);
            digitalWrite (led_2, LOW);
            digitalWrite (led_4, LOW);
    }                   
                   break;                   
    case 6: { 
            digitalWrite (led_2, LOW);
            digitalWrite (led_4, LOW);
            digitalWrite (led_6, LOW);
    }                   
                   break;                       

  }  
}
    
